#include "ImageCanvas.h"
#include "ImageViewer.h"

ImageCanvas::ImageCanvas(QWidget *parent, QImage *img):QWidget(parent,0) {
  limage = img;
  setMouseTracking(TRUE);
}

void ImageCanvas::paintEvent ( QPaintEvent * event) {
  if(limage !=0) {
    QPainter painter( this );
    painter.drawImage(0,0, *limage);
  }
}

void ImageCanvas::setImage( QImage *i) {
  limage = i;
  if(limage != 0) {
    QSize s = limage->size();
    setFixedSize(s);
  }
  repaint();
}

void ImageCanvas::mouseMoveEvent( QMouseEvent *e) {
  if(limage !=0) {
    const QPoint &p = e->pos();
    int x = p.x();
    int y = p.y();

    if(limage->valid(x,y)) { // si on est bien a l'interieur de l'image
      QRgb color = limage->pixel(x,y);
      emit setPixel(x,y,qRed(color),qGreen(color),qBlue(color));
    }
    else {
      emit setPixel("hors de l'image");
    }
  }
}
