#include "ImageViewer.h"

ImageViewer::ImageViewer( QImage *img) : QMainWindow(){
  QWidget *widget = new QWidget(this);
  setCentralWidget(widget);
  
  QPopupMenu *file = new QPopupMenu(this);
  QPopupMenu *edit = new QPopupMenu(this, "&Edit");
  menuBar()->insertItem( "&File", file );
  menuBar()->insertItem( "&Edit", edit );
  file->insertItem( "&Open",  this, SLOT(openImage()), CTRL+Key_O );
  file->insertSeparator();
  file->insertItem( "E&xit", qApp, SLOT(quit()), CTRL+Key_Q );

  QVBoxLayout *box = new QVBoxLayout(widget);

  icanvas = new ImageCanvas(widget,img);
  box->addWidget(icanvas);

  pixel = new QLabel(widget, QString(""));
  box->addWidget(pixel);
  info = new QLabel(widget, QString("Ouvrons l'image !"));
  box->addWidget(info);

  connect(icanvas, SIGNAL(setPixel(int,int,int,int,int)),this, SLOT(setPixel(int,int,int,int,int)));
  connect(icanvas, SIGNAL(setPixel(QString)),this, SLOT(setPixel(QString)));
 }

void ImageViewer::openImage() {
  QFileDialog *fd = new QFileDialog(QString("/home/damien/"),QString("Images (*.png *.jpg)"), this, "Open Image Dialog");
  QString fileName;  
  if(fd->exec() == QDialog::Accepted) {
    fileName = fd->selectedFile();
//    cerr << "ouverture du fichier : " << fileName << endl;
    icanvas->setImage(new QImage(fileName));
    info->setText("Image " + fileName + " ouverte.");
  }
}

void ImageViewer::setPixel(int x, int y, int r, int g, int b) {
  QString s;
  QTextStream( &s, IO_ReadWrite ) << "( x = " << x << " ; y = " << y << ")  : r = " << r << " ; g = " << g << " ; b = " << b ;
  pixel->setText(s);
}
void ImageViewer::setPixel(QString s) {
  pixel->setText(s);
}

int main(int argc, char  **argv) {
  //Q_INIT_RESOURCE(application);

  QApplication app(argc, argv);

  ImageViewer iv ;
  iv.show();

  return app.exec();
}
